// Code generated by go-swagger; DO NOT EDIT.

package read

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/ory/keto/internal/httpclient/models"
)

// PostCheckReader is a Reader for the PostCheck structure.
type PostCheckReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PostCheckReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewPostCheckOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 400:
		result := NewPostCheckBadRequest()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewPostCheckForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewPostCheckInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("response status code does not match any response statuses defined for this endpoint in the swagger spec", response, response.Code())
	}
}

// NewPostCheckOK creates a PostCheckOK with default headers values
func NewPostCheckOK() *PostCheckOK {
	return &PostCheckOK{}
}

/* PostCheckOK describes a response with status code 200, with default header values.

getCheckResponse
*/
type PostCheckOK struct {
	Payload *models.GetCheckResponse
}

func (o *PostCheckOK) Error() string {
	return fmt.Sprintf("[POST /check][%d] postCheckOK  %+v", 200, o.Payload)
}
func (o *PostCheckOK) GetPayload() *models.GetCheckResponse {
	return o.Payload
}

func (o *PostCheckOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.GetCheckResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostCheckBadRequest creates a PostCheckBadRequest with default headers values
func NewPostCheckBadRequest() *PostCheckBadRequest {
	return &PostCheckBadRequest{}
}

/* PostCheckBadRequest describes a response with status code 400, with default header values.

The standard error format
*/
type PostCheckBadRequest struct {
	Payload *PostCheckBadRequestBody
}

func (o *PostCheckBadRequest) Error() string {
	return fmt.Sprintf("[POST /check][%d] postCheckBadRequest  %+v", 400, o.Payload)
}
func (o *PostCheckBadRequest) GetPayload() *PostCheckBadRequestBody {
	return o.Payload
}

func (o *PostCheckBadRequest) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(PostCheckBadRequestBody)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostCheckForbidden creates a PostCheckForbidden with default headers values
func NewPostCheckForbidden() *PostCheckForbidden {
	return &PostCheckForbidden{}
}

/* PostCheckForbidden describes a response with status code 403, with default header values.

getCheckResponse
*/
type PostCheckForbidden struct {
	Payload *models.GetCheckResponse
}

func (o *PostCheckForbidden) Error() string {
	return fmt.Sprintf("[POST /check][%d] postCheckForbidden  %+v", 403, o.Payload)
}
func (o *PostCheckForbidden) GetPayload() *models.GetCheckResponse {
	return o.Payload
}

func (o *PostCheckForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.GetCheckResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostCheckInternalServerError creates a PostCheckInternalServerError with default headers values
func NewPostCheckInternalServerError() *PostCheckInternalServerError {
	return &PostCheckInternalServerError{}
}

/* PostCheckInternalServerError describes a response with status code 500, with default header values.

The standard error format
*/
type PostCheckInternalServerError struct {
	Payload *PostCheckInternalServerErrorBody
}

func (o *PostCheckInternalServerError) Error() string {
	return fmt.Sprintf("[POST /check][%d] postCheckInternalServerError  %+v", 500, o.Payload)
}
func (o *PostCheckInternalServerError) GetPayload() *PostCheckInternalServerErrorBody {
	return o.Payload
}

func (o *PostCheckInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(PostCheckInternalServerErrorBody)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

/*PostCheckBadRequestBody post check bad request body
swagger:model PostCheckBadRequestBody
*/
type PostCheckBadRequestBody struct {

	// code
	Code int64 `json:"code,omitempty"`

	// details
	Details []interface{} `json:"details"`

	// message
	Message string `json:"message,omitempty"`

	// reason
	Reason string `json:"reason,omitempty"`

	// request
	Request string `json:"request,omitempty"`

	// status
	Status string `json:"status,omitempty"`
}

// Validate validates this post check bad request body
func (o *PostCheckBadRequestBody) Validate(formats strfmt.Registry) error {
	return nil
}

// ContextValidate validates this post check bad request body based on context it is used
func (o *PostCheckBadRequestBody) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (o *PostCheckBadRequestBody) MarshalBinary() ([]byte, error) {
	if o == nil {
		return nil, nil
	}
	return swag.WriteJSON(o)
}

// UnmarshalBinary interface implementation
func (o *PostCheckBadRequestBody) UnmarshalBinary(b []byte) error {
	var res PostCheckBadRequestBody
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*o = res
	return nil
}

/*PostCheckInternalServerErrorBody post check internal server error body
swagger:model PostCheckInternalServerErrorBody
*/
type PostCheckInternalServerErrorBody struct {

	// code
	Code int64 `json:"code,omitempty"`

	// details
	Details []interface{} `json:"details"`

	// message
	Message string `json:"message,omitempty"`

	// reason
	Reason string `json:"reason,omitempty"`

	// request
	Request string `json:"request,omitempty"`

	// status
	Status string `json:"status,omitempty"`
}

// Validate validates this post check internal server error body
func (o *PostCheckInternalServerErrorBody) Validate(formats strfmt.Registry) error {
	return nil
}

// ContextValidate validates this post check internal server error body based on context it is used
func (o *PostCheckInternalServerErrorBody) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (o *PostCheckInternalServerErrorBody) MarshalBinary() ([]byte, error) {
	if o == nil {
		return nil, nil
	}
	return swag.WriteJSON(o)
}

// UnmarshalBinary interface implementation
func (o *PostCheckInternalServerErrorBody) UnmarshalBinary(b []byte) error {
	var res PostCheckInternalServerErrorBody
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*o = res
	return nil
}
