// Code generated by go-swagger; DO NOT EDIT.

package write

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// DeleteRelationTupleReader is a Reader for the DeleteRelationTuple structure.
type DeleteRelationTupleReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *DeleteRelationTupleReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 204:
		result := NewDeleteRelationTupleNoContent()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 400:
		result := NewDeleteRelationTupleBadRequest()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewDeleteRelationTupleInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("response status code does not match any response statuses defined for this endpoint in the swagger spec", response, response.Code())
	}
}

// NewDeleteRelationTupleNoContent creates a DeleteRelationTupleNoContent with default headers values
func NewDeleteRelationTupleNoContent() *DeleteRelationTupleNoContent {
	return &DeleteRelationTupleNoContent{}
}

/* DeleteRelationTupleNoContent describes a response with status code 204, with default header values.

Empty responses are sent when, for example, resources are deleted. The HTTP status code for empty responses is typically 201.
*/
type DeleteRelationTupleNoContent struct {
}

func (o *DeleteRelationTupleNoContent) Error() string {
	return fmt.Sprintf("[DELETE /relation-tuples][%d] deleteRelationTupleNoContent ", 204)
}

func (o *DeleteRelationTupleNoContent) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	return nil
}

// NewDeleteRelationTupleBadRequest creates a DeleteRelationTupleBadRequest with default headers values
func NewDeleteRelationTupleBadRequest() *DeleteRelationTupleBadRequest {
	return &DeleteRelationTupleBadRequest{}
}

/* DeleteRelationTupleBadRequest describes a response with status code 400, with default header values.

The standard error format
*/
type DeleteRelationTupleBadRequest struct {
	Payload *DeleteRelationTupleBadRequestBody
}

func (o *DeleteRelationTupleBadRequest) Error() string {
	return fmt.Sprintf("[DELETE /relation-tuples][%d] deleteRelationTupleBadRequest  %+v", 400, o.Payload)
}
func (o *DeleteRelationTupleBadRequest) GetPayload() *DeleteRelationTupleBadRequestBody {
	return o.Payload
}

func (o *DeleteRelationTupleBadRequest) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(DeleteRelationTupleBadRequestBody)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewDeleteRelationTupleInternalServerError creates a DeleteRelationTupleInternalServerError with default headers values
func NewDeleteRelationTupleInternalServerError() *DeleteRelationTupleInternalServerError {
	return &DeleteRelationTupleInternalServerError{}
}

/* DeleteRelationTupleInternalServerError describes a response with status code 500, with default header values.

The standard error format
*/
type DeleteRelationTupleInternalServerError struct {
	Payload *DeleteRelationTupleInternalServerErrorBody
}

func (o *DeleteRelationTupleInternalServerError) Error() string {
	return fmt.Sprintf("[DELETE /relation-tuples][%d] deleteRelationTupleInternalServerError  %+v", 500, o.Payload)
}
func (o *DeleteRelationTupleInternalServerError) GetPayload() *DeleteRelationTupleInternalServerErrorBody {
	return o.Payload
}

func (o *DeleteRelationTupleInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(DeleteRelationTupleInternalServerErrorBody)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

/*DeleteRelationTupleBadRequestBody delete relation tuple bad request body
swagger:model DeleteRelationTupleBadRequestBody
*/
type DeleteRelationTupleBadRequestBody struct {

	// code
	Code int64 `json:"code,omitempty"`

	// details
	Details []interface{} `json:"details"`

	// message
	Message string `json:"message,omitempty"`

	// reason
	Reason string `json:"reason,omitempty"`

	// request
	Request string `json:"request,omitempty"`

	// status
	Status string `json:"status,omitempty"`
}

// Validate validates this delete relation tuple bad request body
func (o *DeleteRelationTupleBadRequestBody) Validate(formats strfmt.Registry) error {
	return nil
}

// ContextValidate validates this delete relation tuple bad request body based on context it is used
func (o *DeleteRelationTupleBadRequestBody) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (o *DeleteRelationTupleBadRequestBody) MarshalBinary() ([]byte, error) {
	if o == nil {
		return nil, nil
	}
	return swag.WriteJSON(o)
}

// UnmarshalBinary interface implementation
func (o *DeleteRelationTupleBadRequestBody) UnmarshalBinary(b []byte) error {
	var res DeleteRelationTupleBadRequestBody
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*o = res
	return nil
}

/*DeleteRelationTupleInternalServerErrorBody delete relation tuple internal server error body
swagger:model DeleteRelationTupleInternalServerErrorBody
*/
type DeleteRelationTupleInternalServerErrorBody struct {

	// code
	Code int64 `json:"code,omitempty"`

	// details
	Details []interface{} `json:"details"`

	// message
	Message string `json:"message,omitempty"`

	// reason
	Reason string `json:"reason,omitempty"`

	// request
	Request string `json:"request,omitempty"`

	// status
	Status string `json:"status,omitempty"`
}

// Validate validates this delete relation tuple internal server error body
func (o *DeleteRelationTupleInternalServerErrorBody) Validate(formats strfmt.Registry) error {
	return nil
}

// ContextValidate validates this delete relation tuple internal server error body based on context it is used
func (o *DeleteRelationTupleInternalServerErrorBody) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (o *DeleteRelationTupleInternalServerErrorBody) MarshalBinary() ([]byte, error) {
	if o == nil {
		return nil, nil
	}
	return swag.WriteJSON(o)
}

// UnmarshalBinary interface implementation
func (o *DeleteRelationTupleInternalServerErrorBody) UnmarshalBinary(b []byte) error {
	var res DeleteRelationTupleInternalServerErrorBody
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*o = res
	return nil
}
